/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Array_$type, Point_$type, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ViewportUtils } from "./ViewportUtils";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let RadialAreaSeries = /*@__PURE__*/ (() => {
    class RadialAreaSeries extends AnchoredRadialSeries {
        constructor() {
            super();
            this.ab = RadialAreaSeries.$;
        }
        bk() {
            return new RadialAreaSeries();
        }
        get_ew() {
            return true;
        }
        ct() {
            return new RadialAreaSeriesView(this);
        }
        q7(a) {
            super.q7(a);
            this.adx = a;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        pb(a, b) {
            super.pb(a, b);
            this.adx.dj();
        }
        abk(a, b) {
            super.abk(a, b);
            let c = b.ca;
            let d = b.b9;
            let e = b.getEffectiveViewport();
            let f = b;
            if (b.r() && !c.isEmpty && !d.isEmpty && this.y9 != null && this.zf != null) {
                let g = a.h;
                let h = g.count;
                let i = new List$1(Array_$type, 2, h);
                let j = 0;
                for (let k = 0; k < h; k++) {
                    let l = new Array(4);
                    i.add(l);
                    l[0] = this.zg.d(a.h._inner[k][0], a.h._inner[k][1], c, d, e);
                    l[1] = this.zg.e(a.h._inner[k][0], a.h._inner[k][1], c, d, e);
                    l[2] = this.zg.d(a.h._inner[k][0], a.h._inner[k][2], c, d, e);
                    let m = a.h._inner[k][2];
                    l[3] = this.zg.e(a.h._inner[k][0], m, c, d, e);
                    if (m > j) {
                        j = m;
                    }
                }
                let n = ViewportUtils.e(0.5, c, d, e);
                let o = ViewportUtils.i(0.5, c, d, e);
                this.adw = { $type: Point_$type, x: n, y: o };
                let p = this.getEffectiveViewport1(f);
                this.zo.a2(this, this.z5(), runOn(this, this.yx), this.aae(b), this.aaf(b));
                let q = false;
                let r = this.zo.b;
                if (r != null) {
                    q = true;
                }
                if (q) {
                    let s = new ScalerParams(0, b.ca, b.b9, this.y9.df, p);
                    this.add(g, -1, this.acg.count, this.y9, s, b.t);
                }
                let t = f.ds;
                let u = f.dt;
                let v = f.dq;
                let w = f.dr;
                this.zo.ad(t, true, false, true, true);
                this.zo.ad(u, true, false, true, true);
                this.zo.ad(v, false, true, false, false);
                this.zo.ad(w, false, true, false, false);
                f.dk(a.h.count, i, false, this.adx.da.b, this.ie, runOn(this, this.ade), this.ady);
                v._opacity = this.zo.j * this.ia;
                w._opacity = 0.5 * this.zo.j * this.ia;
            }
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.qa(a, c, b);
            return c.toArray();
        }
        qa(a, b, c) {
            this.ada(a, b, c, this.za);
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case RadialAreaSeries.$$p[0]:
                    this.ry(false);
                    this.qr();
                    break;
            }
        }
        get_acm() {
            return true;
        }
    }
    RadialAreaSeries.$t = markType(RadialAreaSeries, 'RadialAreaSeries', AnchoredRadialSeries.$);
    RadialAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:ady:ad0', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialAreaSeries;
})();
/**
 * @hidden
 */
export let RadialAreaSeriesView = /*@__PURE__*/ (() => {
    class RadialAreaSeriesView extends AnchoredRadialSeriesView {
        constructor(a) {
            super(a);
            this.di = null;
            this.dq = new Path();
            this.ds = new Path();
            this.dr = new Path();
            this.dt = new Path();
            this.dl = new Path();
            this.dn = new Path();
            this.dm = new Path();
            this.dp = new Path();
            this.di = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.di.xk = Defaults.e;
            }
        }
        dj() {
            this.dq.an = null;
            this.ds.an = null;
            this.dr.an = null;
            this.dt.an = null;
            this.dl.an = null;
            this.dn.an = null;
            this.dm.an = null;
            this.dp.an = null;
            this.a2();
        }
        dk(a, b, c, d, e, f, g) {
            this.de.acb.i(this.dq, this.ds, this.dr, this.dt, a, b, c, d, e, f, g);
            this.a2();
        }
        bp() {
            super.bp();
        }
        bq() {
            super.bq();
            let a = this.b3();
            this.dn.an = this.ds.an;
            this.dp.an = this.dt.an;
            this.dl.an = this.dq.an;
            this.dm.an = this.dr.an;
            this.dn._stroke = a;
            this.dn.ad = this.f.ig + 3;
            this.dp._stroke = a;
            this.dp.ad = this.f.ig + 3;
            this.dl._fill = a;
            this.dl._opacity = 1;
            this.dm._fill = a;
            this.dm._opacity = 1;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.dl);
                    a.t(this.dm);
                    a.t(this.dn);
                    a.t(this.dp);
                }
                else {
                    a.t(this.dq);
                    a.t(this.dr);
                    a.t(this.ds);
                    a.t(this.dt);
                }
            }
        }
        ax(a) {
            super.ax(a);
            this.f.bc.exportPathData(a, this.ds, "lowerShape", ["Lower"]);
            this.f.bc.exportPathData(a, this.dt, "upperShape", ["Upper", "Main"]);
            this.f.bc.exportPathData(a, this.dr, "translucentShape", ["Translucent"]);
            this.f.bc.exportPathData(a, this.dq, "fillShape", ["Fill"]);
        }
    }
    RadialAreaSeriesView.$t = markType(RadialAreaSeriesView, 'RadialAreaSeriesView', AnchoredRadialSeriesView.$);
    return RadialAreaSeriesView;
})();
